#pragma once
#ifndef ANVILCHUNK_HPP
#define ANVILCHUNK_HPP

#include "Chunk.hpp"

class Section
{
public:
	int y;

	BYTE* blocks;
	BYTE* blockData;
	BYTE* skyLight;
	BYTE* blockLight;

	Section();
	~Section();
};

class AnvilChunk : public Chunk
{
public:
	AnvilChunk();
	~AnvilChunk();

	BYTE ReadBlock(int x, int z, int y);
	BYTE ReadBlockData(int x, int z, int y);
	BYTE ReadBlockLight(int x, int z, int y);
	virtual int GetHeight(int x, int y, int z = ANVILZ, int minZ = 0);
	virtual Color GetColor(int x, int y, int z, bool side = false);


protected:
	Section** sections;
	int* anvilHeightMap;

	virtual void Allocate();
	virtual void Deallocate();
	virtual bool ParseNBT(void*);

	virtual void PassExclude(int & x, int & y, int & z, Color & color);
	virtual void PassNight(int & x, int & y, int & z, Color & color);

	void Transform(int &x, int &z);
};

#endif // ANVILCHUNK_HPP
