

#pragma once
#ifndef DATAVALUES_HPP

//#include "Globals.hpp"
#include "String.hpp"

#include "Color.hpp"

#define BLOCKAMOUNT_MAX 256

// Defined
enum DataValues_List
{
	AIR = 0,
	STONE,
	GRASS,
	DIRT,
	COBBLESTONE,
	WOOD,
	SAPLING,
	BEDROCK,
	WATER,
	STATIONARYWATER,
	LAVA,
	STATIONARYLAVA,
	SAND,
	GRAVEL,
	GOLDORE,
	IRONORE,
	COALORE,
	LOG,
	LEAVES,
	SPONGE,
	GLASS,
	LAPIZLAZULIORE,
	LAPIZLAZULIBLOCK,
	DISPENSER,
	SANDSTONE,
	NOTEBLOCK,
	BED,
	POWEREDRAIL,
	DETECTORRAIL,
	STICKYPISTON,
	CODWEB,
	TALLGRASS,
	DEADSHRUBS,
	PISTON,
	PISTONEXTENSION,
	WOOL,
	BLOCKMOVEDBYPISTON,
	YELLOWFLOWER,
	REDROSE,
	BROWNMUSHROOM,
	REDMUSHROOM,
	GOLDBLOCK,
	IRONBLOCK,
	DOUBLESLAB_STONE,
	SLAB_STONE,
	BRICK,
	TNT,
	BOOKSHELF,
	MOSSYCOBBLESTONE,
	OBSIDIAN,
	TORCH,
	FIRE,
	MOBSPAWNER,
	WOODENSTAIRS,
	CHEST,
	REDSTONEWIRE,
	DIAMONDORE,
	DIAMONDBLOCK,
	WORKBENCH,
	CROPS,
	SOIL,
	FURNACE,
	BURNINGFURNACE,
	SIGNPOST,
	WOODENDOOR,
	LADDER,
	MINECARTTRACK,
	COBBLESTONESTAIRS,
	WALLSIGN,
	LEVER,
	STONEPRESSUREPLATE,
	IRONDOOR,
	WOODPRESSUREPLATE,
	REDSTONEORE,
	GLOWINGREDSTONEORE,
	REDSTONETORCHON,
	REDSTONETORCHOFF,
	STONEBUTTON,
	SNOW,
	ICE,
	SNOWBLOCK,
	CACTUS,
	CLAY,
	REED,
	JUKEBOX,
	FENCE,
	PUMPKIN,
	BLOODSTONE,
	SLOWSAND,
	LIGHTSTONE,
	PORTAL,
	JACKOLANTERN,
	CAKE,
	REPEATEROFF,
	REPEATERON,
	LOCKEDCHEST, // Removed
	TRAPDOOR,
	HIDDENSILVERFISH,
	STONEBRICKS,
	HUGEBROWNMUSHROOM,
	HUGEREDMUSHROOM,
	IRONBARS,
	GLASSPANE,
	MELON,
	PUMKINSTEM,
	MELONSTEM,
	VINES,
	FENCEGATE,
	BRICKSTAIRS,
	STONEBRICKSTAIRS,
	MYCELIUM,
	LILYPAD,
	NETHERBRICK,
	NETHERBRICKFENCE,
	NETHERBRICKSTAIRS,
	NETHERWART,
	ENCHANTMENTTABLE,
	BREWINGSTAND,
	CAULDRON,
	ENDPORTAL,
	ENDPORTALFRAME,
	ENDSTONE,
	DRAGONEGG,
	REDSTONELAMPOFF,
	REDSTONELAMPON,

	BLOCKAMOUNT,

	WOOLCOLOR = BLOCKAMOUNT,
	WOOLWHITE = WOOLCOLOR,
	WOOLORANGE,
	WOOLMAGENTA,
	WOOLLIGHTBLUE,
	WOOLYELLOW,
	WOOLLIMEGREEN,
	WOOLPINK,
	WOOLGRAY,
	WOOLLIGHTGRAY,
	WOOLCYAN,
	WOOLBLUE,
	WOOLBROWN,
	WOOLGREEN,
	WOOLRED,
	WOOLBLACK,
	WOOLPURPLE,
	WOOLUNKNOWN,

	LOGCOLOR,
	LOGNORMAL = LOGCOLOR,
	LOGREDWOOD,
	LOGBIRCH,

	LEAFCOLOR,
	LEAFNORMAL = LEAFCOLOR,
	LEAFREDWOOD,
	LEAFBIRCH,

	SLABCOLOR,
	SLABSTONE = SLABCOLOR, //0
	SLABSAND, //1
	SLABWOOD, //2
	SLABCOBBLE, //3
	SLABBRICK, //4
	SLABSTONEBRICK, //5
	SLABUNUSED1, //6
	SLABUNUSED2, //7
	SLABSTONETOP, //8
	SLABSANDTOP, //9
	SLABWOODTOP, //10
	SLABCOBBLETOP, //11
	SLABBRICKTOP, //12
	SLABSTONEBRICKTOP, //13

	DATAVALUES_MAX_AMOUNT,
	DATAVALUES_AMOUNT = 256 + (DATAVALUES_MAX_AMOUNT - BLOCKAMOUNT)
};

class DataValues
{
public:
	static void MakeColor();
	static void MakeColor(STRING file);

	static Color GetColor(unsigned short c);

	static STRING GetBlockName(unsigned char c);

private:
	static Color colorData[DATAVALUES_AMOUNT];
	static STRING colorName[BLOCKAMOUNT_MAX];
};

#endif // DATAVALUES_HPP