

#include "Number.hpp"

#include "String.hpp"

#ifdef UNIX
#include <stdlib.h>
#endif

// Chops thousand
std::string chopThousand(INT64 & number)
{
	std::stringstream str;
	INT64 remainder = number % 1000;
	number /= 1000;
	str << (number == 0 ? remainder : (remainder < 0 ? -remainder : remainder));
	std::string more = str.str();
	while (more.size() < 3 && number)
		more = "0" + more;
	return more;
}

// Chops thousand
std::string chopThousand(int & number)
{
	std::stringstream str;
	int remainder = number % 1000;
	number /= 1000;
	str << (number == 0 ? remainder : (remainder < 0 ? -remainder : remainder));
	std::string more = str.str();
	while (more.size() < 3 && number)
		more = "0" + more;
	return more;
}

// Sets a separator for a number
std::string Port::setSeparator(INT64 number, char c)
{
	std::string temp;

	temp = chopThousand(number);
	
	while (number)
		temp = chopThousand(number) + c + temp;

	return temp;
}

// Sets a separator for a number
std::string Port::setSeparator(int number, char c)
{
	std::string temp;

	temp = chopThousand(number);
	
	while (number)
		temp = chopThousand(number) + c + temp;

	return temp;
}

// Sets a separator for a string
std::string Port::setSeparator(std::string str, char c)
{
#ifdef WIN32
	return setSeparator(_atoi64(str.c_str()), c);
#elif defined(UNIX)
	return setSeparator(atoll(str.c_str()), c);
#endif
}