
// Region Reader
// Made by McTwist

#pragma once
#ifndef REGION_HPP
#define REGION_HPP

#include <vector>

//#include "Globals.hpp"
#include "String.hpp"
#include "Number.hpp"

const int MAX_CHUNKS = 32 * 32;

enum CompressionType
{
	COMPRESSION_UNKNOWN,
	COMPRESSION_GZIP,
	COMPRESSION_DEFLATE
};

class RegionReader
{
public:
	RegionReader();
	~RegionReader();

	void Clear();

	bool Load(const STRING & file);
	BYTE * GetChunk(size_t index, UINT & size);
	size_t GetAmountChunks();

	void ParseData();
	void ParseHeader();
	void ParseTimestamp();
	void ParseSectors();

private:
	struct ChunkOffset
	{
		int sector_number;
		BYTE sector_count;
		int timestamp;
	} offsets[MAX_CHUNKS];
	struct Sector
	{
		int length;
		BYTE version;
		BYTE * data;
	};
	std::vector<Sector> sectors;

	BYTE * data;
	//int size;
	int amount;
	size_t chunks;
};

#endif // REGION_HPP