

#include "String.hpp"

#include "Number.hpp"

#include <wchar.h>
#include <stdio.h>

// Make a correct string of ansi or unicode
STRING Port::MakeString(const char * text)
{
	STRING str;
	str.assign(text, text+strlen(text));
	return str;
}

// Replace character in string
WSTRING Port::Replace(WSTRING str, wchar_t from, wchar_t to)
{
	for (UINT i = 0; i < str.size(); ++i)
		if (str[i] == from)
			str[i] = to;
	return str;
}
ASTRING Port::Replace(ASTRING str, char from, char to)
{
	for (UINT i = 0; i < str.size(); ++i)
		if (str[i] == from)
			str[i] = to;
	return str;
}

// Convert from one encoding to another
ASTRING Port::ConvertEncoding(WSTRING str)
{
	return ASTRING(str.begin(), str.end());
}

WSTRING Port::ConvertEncoding(ASTRING str)
{
	return WSTRING(str.begin(), str.end());
}

// Get size of character string
size_t Port::StrLen(const char * str)
{
	return strlen(str);
}

size_t Port::StrLen(const wchar_t * str)
{
	return wcslen(str);
}

// Default limit is 4096 (Would be enough in most cases)
const size_t bufferSize = 4096;

int Port::SPrintf(ASTRING & str, const char * format, ...)
{
	va_list args;
	va_start(args, format);
	int size = SPrintf(str, format, args);
	va_end(args);
	return size;
}

int Port::SPrintf(ASTRING & str, const char * format, va_list args)
{
	char buffer[bufferSize] = {0};
#ifdef WIN32
	int size = vsprintf_s(buffer, bufferSize, format, args);
#else
	int size = vsprintf(buffer, format, args);
#endif // WIN32
	str.assign(buffer);
	return size;
}

int Port::SPrintf(WSTRING & str, const wchar_t * format, ...)
{
	va_list args;
	va_start(args, format);
	int size = SPrintf(str, format, args);
	va_end(args);
	return size;
}

int Port::SPrintf(WSTRING & str, const wchar_t * format, va_list args)
{
	wchar_t buffer[bufferSize] = {0};
	int size = vswprintf(buffer, bufferSize, format, args);
	str.assign(buffer);
	return size;
}