

#pragma once
#ifndef SYSTEM_HPP
#define SYSTEM_HPP

#include "String.hpp"

#include "Number.hpp"

// Thread function
#ifdef WIN32
#define THREAD_FUNCTION(func, arg) DWORD WINAPI func(PVOID arg)
#elif defined(UNIX)
#define THREAD_FUNCTION(func, arg) void * func(void * arg)
#endif

namespace Port
{
	// Get environement variable
	STRING GetEnv(const char * var);
	// Get current working directory
	STRING GetCurrentDir();
	// Change current working directory
	bool SetCurrentDir(STRING str);
	// Make portable path
	STRING ReplacePath(STRING path);
	// Get filename from path
	STRING FileName(STRING file);
	// Get path from string
	STRING Directory(STRING str);
	// Path exists
	bool ExistPath(STRING path);
	// Return value of how a path is ubuilt up
	
#define TELLPATH_EXIST 1
#define TELLPATH_FILE 2
#define TELLPATH_DIR 4
#define TELLPATH_END_SLASH 8
// 1 - Exist
// 2 - File
// 4 - Dir with no ending slash
// 8 - Dir with ending slash

	// Tell how path is built up
	int TellPath(STRING path);
	// Portable Sleep
	void Rest(UINT milli);

	size_t GetAvailableMemory();
	size_t GetTotalMemory();
	size_t GetLogicalCores();
}

#endif // SYSTEM_HPP